
#include "ipxfury.h"
#include <stdio.h>
#include <string.h>
#include <ctype.h>


void hexdump(unsigned char *data, int len)
{
#ifdef CURSES_CONSOLE
	errormsg(0, "hexdump", "no hexdump available yet!");
	return;
#else
	fhexdump(stdout, data, len);
#endif
}

void fhexdump(FILE *out, unsigned char *data, int len)
{
  unsigned char		ascii_buf[17];
  unsigned char		*ptr;
  unsigned short	offset, ascii_idx, loop_counter, spaces;

	if( out == NULL ) {	
		return;
	}
  
  offset = 0;
  ptr = data;
  while( offset < len ) {
    bzero(ascii_buf, 17);
    ascii_idx = 0x00;
    fprintf(out, "%.4X:", offset);
    if( (len - offset) >= 16 ) {	/* easy */
      for( loop_counter = 0; loop_counter < 16; loop_counter++ ) {
        if( loop_counter == 8 )	fputc(' ', out);
        fprintf(out, " %.2X", *ptr);
        if( isprint(*ptr) )
          ascii_buf[ascii_idx] = *ptr;
        else
        ascii_buf[ascii_idx] = '.';
        ptr++;
        ascii_idx++;
      } /* for */
      offset += 16;
    } else {				/* less than 16 bytes */
      for( loop_counter = 0; loop_counter < (len - offset); loop_counter++ ) {
        if( loop_counter == 8 )	fputc(' ', out);
        fprintf(out, " %.2X", *ptr);
        if( isprint(*ptr) )
          ascii_buf[ascii_idx] = *ptr;
        else
        ascii_buf[ascii_idx] = '.';
        ptr++;
        ascii_idx++;
      } /* for */
      spaces = 0x00;
      if( (len - offset) <= 8 )	spaces++;
      spaces += 3 * (16 - (len - offset));
      for( loop_counter = 0; loop_counter < spaces; loop_counter++ )
        fputc(' ', out);
      offset += (len - offset);
    }
    fprintf(out, "   %s\n", ascii_buf);
  } /* while */
  

}

